/*Usporediti brzinu rekurzivne (obicne), rekurzivne s cachom
i iteretivne funkcije*/

#include <stdio.h>

long unsigned fib_rek(unsigned n)
{
    if(n<=1) return n;
    return fib_rek(n-1)+fib_rek(n-2);
}

long unsigned fib_rek_cache(unsigned n)
{
    static long unsigned fib_cache[10000]={0};
    if(n<=1) return n;
    if(fib_cache[n]) return fib_cache[n];
    return fib_cache[n]=fib_rek_cache(n-1)+fib_rek_cache(n-2);
}

long unsigned fib_ite(unsigned n)
{
    unsigned long fib0=0, fib1=1, fib2;
    unsigned i;
    if(n<=1) return n;

    for(i=2; i<=n; i++){
        fib2=fib1+fib0;
        fib0=fib1;
        fib1=fib2;
    }
    return fib2;
}

int main(void)
{
    return fib_rek(43);
}
