#include <stdio.h>

void part_ispis(int x, int br2, int br3, int br5)
{
    if(x<0) return;
    if(x==0){
        ispis_rastava(br2,br3,br5);
        return;
    }
    if(br3==0){
        part_ispis(x-2,br2+1,br3,br5);
    }
    if(br5==0){
        part_ispis(x-3,br2,br3+1,br5);
    }
    part_ispis(x-5,br2,br3,br5+1);
    return;
}

/*
Ustvrdili smo da je prikaz jedinstven cim znamo broj
dvojki, trojki i petica. 
Sad samo trebamo zapisati funkciju koja ce ispisitvati
zapise.
Probajte napisati raspisani ispis, tj. na primjer u 
slucaju br2=2, br3=1, br5=3 ispisite
2+2+3+5+5+5.
*/
void ispis_rastava(int a, int b, int c)
{
    printf("%dx2+%dx3+%dx5\n", a,b,c);
    return;
}

int main(void)
{
    part_ispis(10,0,0,0);
    return 0;
}
